//+----------------------------------------------------------------------+
//|                                                        bbsqueeze.mq4 |
//|                               not for sale, rent, auction, nor lease |
//+----------------------------------------------------------------------+
#property copyright "www.forex-station.com"
#property link      "www.forex-station.com"
//+----------------------------------------------------------------------+
/*
from mladen
https://forex-station.com/viewtopic.php?p=1295353177#p1295353177
The usual issue with Bollinger bands is the following :
_____________________________
Bollinger bands is defined as SMA +- standard deviations
Now - what is less known, is that standard deviations are calculated using sma too. 
So, they fit naturally (the sma and standard deviations) in the Bollinger bands. 
But as soon as the sma is replaced for some other average type it becomes broken (that connection) 
and in some cases (like the proposed tema) I am not sure that a deviation of tema can be calculated at all. 
It is not just replacing the average for deviation calculations 
- that would be a "hit-and-run" method 
- since that will not reflect the nature of the average
_____________________________
To cut it short : some bands that are calculated as some average +- standard deviations are easy. 
But if that will be deviations of that exact average - that is quite a different story
*/

#property indicator_separate_window
#property indicator_buffers 7
#property indicator_color1  clrGreen
#property indicator_color2  clrRed
#property indicator_color3  clrTeal
#property indicator_color4  clrCrimson
#property indicator_color5  clrGray
#property indicator_color6  clrCrimson // do not trade
#property indicator_color7  clrGreen // OK to trade
#property indicator_width1  2
#property indicator_width2  2
#property indicator_width5  1
#property indicator_width6  1
#property indicator_width7  1
#property strict

//
//
//
//
//

enum enCalcType
{
   st_std, // Use standard deviation 
   st_ste, // Use standard error
   st_sam, // Custom strandard deviation - with sample correction
   st_nos  // Custom strandard deviation - without sample correction
   
};
enum enPrices
{
   pr_close,      // Close
   pr_open,       // Open
   pr_high,       // High
   pr_low,        // Low
   pr_median,     // Median
   pr_typical,    // Typical
   pr_weighted,   // Weighted
   pr_average,    // Average (high+low+open+close)/4
   pr_medianb,    // Average median body (open+close)/2
   pr_tbiased,    // Trend biased price
   pr_tbiased2,   // Trend biased (extreme) price
   pr_hl,         // High/Low
   pr_oc,         // Open/Close
   pr_haclose,    // Heiken ashi close
   pr_haopen ,    // Heiken ashi open
   pr_hahigh,     // Heiken ashi high
   pr_halow,      // Heiken ashi low
   pr_hamedian,   // Heiken ashi median
   pr_hatypical,  // Heiken ashi typical
   pr_haweighted, // Heiken ashi weighted
   pr_haaverage,  // Heiken ashi average
   pr_hamedianb,  // Heiken ashi median body
   pr_hatbiased,  // Heiken ashi trend biased price
   pr_hatbiased2, // Heiken ashi trend biased (extreme) price
   pr_hahl,       // Heiken ashi High/Low
   pr_haoc        // Heiken ashi Open/Close
};

extern ENUM_TIMEFRAMES   TimeFrame            = PERIOD_CURRENT;    // Time frame
extern string            ForexSymbol          = "";                // Symbol to use (leave empty for current symbol)
input int                LRPrd                = 8;                // Linear regression Period
input int                bolPrd               = 15;                // Bollinger Bands Period
input ENUM_MA_METHOD     bolMaMode            = MODE_SMA;          // Bollinger Average method
input double             bolDev               = 2.0;               // Bollinger Bands Deviation
input enCalcType         bolDevType           = st_std;            // Deviation calculation type
input string             note2                = "----about Keltner Channel------------------------------------";
input int                keltPrd              = 20;                // Keltner Period
input double             keltFactor           = 1.5;               // Keltner Spacing between bands
input enPrices           AppliedPrice         = pr_close;          // Price to use
input string             note3                = "-------------------------------------------------------------";
input bool               alertsOn             = True;             // Turn alerts on?
input bool               alertsOnCurrent      = False;             // Alerts on current (still opened) bar?
input bool               alertsOnHisto        = True;             // Alerts on Histo color change
input bool               alertsOnSqueeze      = True;             // Alerts on squeeze
input bool               alertsMessage        = True;             // Alerts showing a pop-up message?
input bool               alertsPushNotif      = True;             // Alerts sending a push notification?
input bool               alertsSound          = True;             // Alerts playing sound?
input bool               alertsEmail          = false;             // Alerts sending email?
input string             soundFile            = "alert2.wav";      // Alerts Sound File to use
input bool               verticalLinesVisible = false;             // Show vertical lines
input bool               linesOnNewest        = false;             // Vertical lines drawn on newest bar of higher time frame bar?
input string             verticalLinesID      = "bb Lines";        // Lines ID
input color              verticalLinesUpColor = clrDodgerBlue;    // Lines up color 
input color              verticalLinesDnColor = clrCrimson;  // Lines down color
input ENUM_LINE_STYLE    verticalLinesStyle   = STYLE_DOT;         // Lines style
input int                verticalLinesWidth   = 0;                 // lines width
input bool               Interpolate          = true;              // Interpolate in multi time frame mode?


double huu[],hud[],hdd[],hdu[],d[],colors[],upK[],dnK[],trend[],values[],count[],prices[];
string indicatorFileName;
#define _mtfCall(_buff,_ind) iCustom(ForexSymbol,TimeFrame,indicatorFileName,PERIOD_CURRENT,"",LRPrd,bolPrd,bolMaMode,bolDev,bolDevType,"",keltPrd,keltFactor,AppliedPrice,"",alertsOn,alertsOnCurrent,alertsOnHisto,alertsOnSqueeze,alertsMessage,alertsPushNotif,alertsSound,alertsEmail,soundFile,verticalLinesVisible,linesOnNewest,verticalLinesID,verticalLinesUpColor,verticalLinesDnColor,verticalLinesStyle,verticalLinesWidth,_buff,_ind)

//------------------------------------------------------------------
//
//------------------------------------------------------------------

int OnInit()
{
   IndicatorBuffers(12);
   SetIndexBuffer(0, huu,INDICATOR_DATA); SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexBuffer(1, hdd,INDICATOR_DATA); SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexBuffer(2, hud,INDICATOR_DATA); SetIndexStyle(2,DRAW_HISTOGRAM);
   SetIndexBuffer(3, hdu,INDICATOR_DATA); SetIndexStyle(3,DRAW_HISTOGRAM);
   SetIndexBuffer(4, d,  INDICATOR_DATA); SetIndexStyle(4,DRAW_LINE);
   SetIndexBuffer(5, upK,INDICATOR_DATA); SetIndexStyle(5,DRAW_ARROW); SetIndexArrow(5,251); //do not trade on red x
   SetIndexBuffer(6, dnK,INDICATOR_DATA); SetIndexStyle(6,DRAW_ARROW); SetIndexArrow(6,159); //OK to trade on green dot
   SetIndexBuffer(7, trend);
   SetIndexBuffer(8, colors);
   SetIndexBuffer(9, values);
   SetIndexBuffer(10,prices);
   SetIndexBuffer(11,count);
   
   
        indicatorFileName = WindowExpertName();
        TimeFrame         = fmax(TimeFrame,_Period);  
        ForexSymbol       = (ForexSymbol=="") ? _Symbol : ForexSymbol; 
        
   IndicatorSetString(INDICATOR_SHORTNAME,timeFrameToString(TimeFrame)+" "+ForexSymbol+" bbsqueeze("+(string)LRPrd+")");
return(INIT_SUCCEEDED);
}
void OnDeinit(const int reason)  
{ 
     string tlookFor       = verticalLinesID+":";
     int    tlookForLength = StringLen(tlookFor);
     for (int i=ObjectsTotal()-1; i>=0; i--)
     {
         string objectName = ObjectName(i);
         if (StringSubstr(objectName,0,tlookForLength) == tlookFor) ObjectDelete(objectName);
     } 
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int OnCalculate(const int rates_total,const int prev_calculated,const datetime &time[],
                const double &open[],
                const double &high[],
                const double &low[],
                const double &close[],
                const long &tick_volume[],
                const long &volume[],
                const int &spread[])
{
   int i,limit=fmin(rates_total-prev_calculated+1,rates_total-1); count[0] = limit;
      if (TimeFrame!=_Period || ForexSymbol!=_Symbol)
      {
         limit = (int)fmax(limit,fmin(rates_total-1,_mtfCall(11,0)*TimeFrame/_Period));
         for (i=limit;i>=0 && !_StopFlag; i--)
         {
            int y = iBarShift(ForexSymbol,TimeFrame,time[i]);
               d[i]      = _mtfCall(4,y);
               huu[i]    = hud[i] = EMPTY_VALUE;
               hdd[i]    = hdu[i] = EMPTY_VALUE;
               upK[i]    = dnK[i] = EMPTY_VALUE;
               trend[i]  = _mtfCall(7,y);
               colors[i] = _mtfCall(8,y);
               values[i] = _mtfCall(9,y);
                     
               if (!Interpolate || (i>0 && y==iBarShift(ForexSymbol,TimeFrame,time[i-1]))) continue;
                  
               //
               //
               //
               //
               //
                  
               #define _interpolate(buff) buff[i+k] = buff[i]+(buff[i+n]-buff[i])*k/n
               int n,k; datetime dtime = iTime(NULL,TimeFrame,y);
                  for(n = 1; (i+n)<rates_total && time[i+n] >= dtime; n++) continue;	
                  for(k = 1; k<n && (i+n)<rates_total && (i+k)<rates_total; k++) _interpolate(d);
         }
         for (i=limit;i>=0; i--)
         {
             if (trend[i] == 1) upK[i] = 0;
             if (trend[i] ==-1) dnK[i] = 0;
             huu[i] = (values[i] == 1 && colors[i] == 1) ? d[i] : EMPTY_VALUE;
             hud[i] = (values[i] == 1 && colors[i] ==-1) ? d[i] : EMPTY_VALUE;
             hdd[i] = (values[i] ==-1 && colors[i] ==-1) ? d[i] : EMPTY_VALUE;
             hdu[i] = (values[i] ==-1 && colors[i] == 1) ? d[i] : EMPTY_VALUE;      
         }
   return(rates_total);
   }               
         
   //
   //
   //
   //
   //
   
   
   for (i=limit; i>=0; i--) prices[i] = getPrice(AppliedPrice,open,close,high,low,i,rates_total);
   for (i=limit; i>=0; i--)
   {
       double std=0;
         switch (bolDevType)
         {
            case st_std : std = iStdDevOnArray(prices,0,bolPrd,0,(int)bolMaMode,i); break;
            case st_ste : std = iStdError(prices[i], bolPrd,i,rates_total);         break;
            default :     std = iDeviation(prices[i],bolPrd,bolDevType==st_sam,i,rates_total);
         }            
         double dt = iMAOnArray(prices,0,bolPrd,0,(int)bolMaMode,i);           
             d[i] = LinearRegressionSlope(LRPrd,i);
               double atr    = iATR(NULL,0,keltPrd,i);
               double UpMa   = dt + std*bolDev;
               double DnMa   = dt - std*bolDev;
               double keltUp = dt + keltFactor*atr;
               double keltDn = dt - keltFactor*atr;
                  trend[i]  = (i<rates_total-1) ? (UpMa<keltUp&&DnMa>keltDn) ? 1 : (UpMa>keltUp&&DnMa<keltDn) ? -1 : trend[i+1]  : 0; 
                  colors[i] = (i<rates_total-1) ? (d[i]>d[i+1])              ? 1 : (d[i]<d[i+1])              ? -1 : colors[i+1] : 0; 
                  values[i] = (i<rates_total-1) ? (d[i]>0)                   ? 1 : (d[i]<0)                   ? -1 : values[i+1] : 0; 
                  huu[i] = hud[i] = EMPTY_VALUE;
                  hdd[i] = hdu[i] = EMPTY_VALUE;
                  upK[i] = dnK[i] = EMPTY_VALUE;
                  huu[i] = (values[i] == 1 && colors[i] == 1) ? d[i] : EMPTY_VALUE;
                  hud[i] = (values[i] == 1 && colors[i] ==-1) ? d[i] : EMPTY_VALUE;
                  hdd[i] = (values[i] ==-1 && colors[i] ==-1) ? d[i] : EMPTY_VALUE;
                  hdu[i] = (values[i] ==-1 && colors[i] == 1) ? d[i] : EMPTY_VALUE;  
                  if (trend[i] == 1) upK[i] = 0;
                  if (trend[i] ==-1) dnK[i] = 0;
                  
                  //
                  //
                  //
                  //
                  //
               
                  if (verticalLinesVisible)
                  {
                     string tlookFor = verticalLinesID+":"+(string)time[i]; ObjectDelete(tlookFor);  
                     if (i<rates_total-1 && values[i]!=values[i+1])
                     {
                       if (values[i] == 1) drawLine(i,verticalLinesUpColor);
                       if (values[i] ==-1) drawLine(i,verticalLinesDnColor);
                     }
                  }
      
                                       
   }
   
   //
   //
   //
   //
   //
   
   if (alertsOn)
   {
      int whichBar = 1; if (alertsOnCurrent) whichBar = 0; 
      static datetime time1 = 0;
      static string   mess1 = "";
      if (alertsOnHisto)
      {
         if (hdu[whichBar+1] == EMPTY_VALUE && hdu[whichBar] != EMPTY_VALUE) doAlert(time1,mess1,whichBar,"weak buy");
         if (huu[whichBar+1] == EMPTY_VALUE && huu[whichBar] != EMPTY_VALUE) doAlert(time1,mess1,whichBar,"strong buy");
         if (hud[whichBar+1] == EMPTY_VALUE && hud[whichBar] != EMPTY_VALUE) doAlert(time1,mess1,whichBar,"weak sell");
         if (hdd[whichBar+1] == EMPTY_VALUE && hdd[whichBar] != EMPTY_VALUE) doAlert(time1,mess1,whichBar,"strong sell");  
      }         
      static datetime time2 = 0;
      static string   mess2 = "";
      if (alertsOnSqueeze && trend[whichBar] != trend[whichBar+1])
      {
           if (trend[whichBar] ==  1 ) doAlert(time2,mess2,whichBar,"squeeze");
           if (trend[whichBar] == -1 ) doAlert(time2,mess2,whichBar,"breaking out");
      }         
      
    }         
return(rates_total);
}

//---------------------------------------------------------------------------------
//
//---------------------------------------------------------------------------------
//
//
//
//
//

int    lrsperiod=EMPTY_VALUE;
double lrssumX;
double lrssumXSqr;
double lrsdivisor;
double LinearRegressionSlope(int len,int shift)
{
   double LinearRegSlope;
   double SumXY = 0;
   double SumY  = 0;

   //
   //
   //
   //
   //

   if (lrsperiod != len)
   {
      lrsperiod  = len;
      lrssumX    = lrsperiod * (lrsperiod-1) / 2;
      lrssumXSqr = lrsperiod * (lrsperiod-1) * (2 * lrsperiod - 1) / 6;
      lrsdivisor = MathPow(lrssumX,2) - lrsperiod * lrssumXSqr;
   }

   //
   //
   //
   //
   //

   for (int i=0; i<lrsperiod && i+shift<Bars; i++)
   {
      double price = prices[i+shift];
            SumXY += i*price;
            SumY  +=   price;
   }
   if( lrsdivisor != 0 ) 
         	LinearRegSlope = (lrsperiod * SumXY - lrssumX * SumY)/lrsdivisor;
   else     LinearRegSlope = 0; 
   return  (LinearRegSlope);
}

//------------------------------------------------------------------
//                                                                  
//------------------------------------------------------------------
// 
//
//
//
//

#define _devInstances 1
double workDev[][_devInstances];
double iDeviation(double value, int length, bool isSample, int i, int bars, int instanceNo=0)
{
   if (ArrayRange(workDev,0)!=bars) ArrayResize(workDev,Bars); i=bars-i-1; workDev[i][instanceNo] = value;
                 
   //
   //
   //
   //
   //
   
      double oldMean   = value;
      double newMean   = value;
      double squares   = 0; int k;
      for (k=1; k<length && (i-k)>=0; k++)
      {
         newMean  = (workDev[i-k][instanceNo]-oldMean)/(k+1)+oldMean;
         squares += (workDev[i-k][instanceNo]-oldMean)*(workDev[i-k][instanceNo]-newMean);
         oldMean  = newMean;
      }
      return(sqrt(squares/fmax(k-isSample,1)));
}

//
//
//
//
//

double workErr[][_devInstances];
double iStdError(double value, int length,int i, int bars, int instanceNo=0)
{
   if (ArrayRange(workErr,0)!=bars) ArrayResize(workErr,bars); i = bars-i-1; workErr[i][instanceNo] = value;
                        
      //
      //
      //
      //
      //
                              
      double avgY     = workErr[i][instanceNo]; int j; for (j=1; j<length && (i-j)>=0; j++) avgY += workErr[i-j][instanceNo]; avgY /= j;
      double avgX     = length * (length-1) * 0.5 / length;
      double sumDxSqr = 0.00;
      double sumDySqr = 0.00;
      double sumDxDy  = 0.00;
   
      for (int k=0; k<length && (i-k)>=0; k++)
      {
         double dx = k-avgX;
         double dy = workErr[i-k][instanceNo]-avgY;
            sumDxSqr += (dx*dx);
            sumDySqr += (dy*dy);
            sumDxDy  += (dx*dy);
      }
      double err2 = (sumDySqr-(sumDxDy*sumDxDy)/sumDxSqr)/(length-2); 
      
   //
   //
   //
   //
   //
         
   if (err2 > 0)
         return(sqrt(err2));
   else  return(0.00);       
}

//
//
//
//
//

void doAlert(datetime& previousTime, string& previousAlert, int forBar, string doWhat)
{
   string message;
   
   if (previousAlert != doWhat || previousTime != Time[forBar]) {
       previousAlert  = doWhat;
       previousTime   = Time[forBar];
       
       //
       //
       //
       //
       //

       message = timeFrameToString(_Period)+" "+_Symbol+" at "+TimeToStr(TimeLocal(),TIME_SECONDS)+" bbsqueeze "+doWhat;
          if (alertsMessage)    Alert(message);
          if (alertsPushNotif)  SendNotification(message);
          if (alertsEmail)      SendMail(_Symbol+" bbsqueeze ",message);
          if (alertsSound)      PlaySound(soundFile);
      }
}

//
//
//
//
//

void drawLine(int i,color theColor)
{
      string name = verticalLinesID+":"+(string)Time[i];
   
      //
      //
      //
      //
      //
         
      datetime time = Time[i]; if (linesOnNewest) time += _Period*60-1;    
      ObjectCreate(name,OBJ_VLINE,0,time,0);
         ObjectSet(name,OBJPROP_COLOR,theColor);
         ObjectSet(name,OBJPROP_STYLE,verticalLinesStyle);
         ObjectSet(name,OBJPROP_WIDTH,verticalLinesWidth);
         ObjectSet(name,OBJPROP_BACK,true);
}

//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

#define _priceInstances     1
#define _priceInstancesSize 4
double workHa[][_priceInstances*_priceInstancesSize];
double getPrice(int price, const double& open[], const double& close[], const double& high[], const double& low[], int i, int bars, int instanceNo=0)
{
  if (price>=pr_haclose)
   {
      if (ArrayRange(workHa,0)!= bars) ArrayResize(workHa,bars); int r = bars-i-1; instanceNo*=_priceInstancesSize;
         
         //
         //
         //
         //
         //
         
         double haOpen;
         if (r>0)
                haOpen  = (workHa[r-1][instanceNo+2] + workHa[r-1][instanceNo+3])/2.0;
         else   haOpen  = (open[i]+close[i])/2;
         double haClose = (open[i] + high[i] + low[i] + close[i]) / 4.0;
         double haHigh  = MathMax(high[i], MathMax(haOpen,haClose));
         double haLow   = MathMin(low[i] , MathMin(haOpen,haClose));

         if(haOpen  <haClose) { workHa[r][instanceNo+0] = haLow;  workHa[r][instanceNo+1] = haHigh; } 
         else                 { workHa[r][instanceNo+0] = haHigh; workHa[r][instanceNo+1] = haLow;  } 
                                workHa[r][instanceNo+2] = haOpen;
                                workHa[r][instanceNo+3] = haClose;
         //
         //
         //
         //
         //
         
         switch (price)
         {
            case pr_haclose:     return(haClose);
            case pr_haopen:      return(haOpen);
            case pr_hahigh:      return(haHigh);
            case pr_halow:       return(haLow);
            case pr_hamedian:    return((haHigh+haLow)/2.0);
            case pr_hamedianb:   return((haOpen+haClose)/2.0);
            case pr_hatypical:   return((haHigh+haLow+haClose)/3.0);
            case pr_haweighted:  return((haHigh+haLow+haClose+haClose)/4.0);
            case pr_haaverage:   return((haHigh+haLow+haClose+haOpen)/4.0);
            case pr_hatbiased:
               if (haClose>haOpen)
                     return((haHigh+haClose)/2.0);
               else  return((haLow+haClose)/2.0);        
            case pr_hatbiased2:
               if (haClose>haOpen)  return(haHigh);
               if (haClose<haOpen)  return(haLow);
                                    return(haClose);        
         }
   }
   
   //
   //
   //
   //
   //
   
   switch (price)
   {
      case pr_close:     return(close[i]);
      case pr_open:      return(open[i]);
      case pr_high:      return(high[i]);
      case pr_low:       return(low[i]);
      case pr_median:    return((high[i]+low[i])/2.0);
      case pr_medianb:   return((open[i]+close[i])/2.0);
      case pr_typical:   return((high[i]+low[i]+close[i])/3.0);
      case pr_weighted:  return((high[i]+low[i]+close[i]+close[i])/4.0);
      case pr_average:   return((high[i]+low[i]+close[i]+open[i])/4.0);
      case pr_tbiased:   
               if (close[i]>open[i])
                     return((high[i]+close[i])/2.0);
               else  return((low[i]+close[i])/2.0);        
      case pr_tbiased2:   
               if (close[i]>open[i]) return(high[i]);
               if (close[i]<open[i]) return(low[i]);
                                     return(close[i]);        
   }                                     
   return(0);
}
